diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index 5c68d7bfb..cb71745cc 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -206,7 +206,7 @@ item.minecart.chest.name=Minecart with Chest
 item.minecart.chest.desc=Great for transporting goods across a rail network.
 item.minecart.furnace.name=Minecart with Furnace
 item.minecart.furnace.desc=Pushes itself forward when fuelled.
-item.egg.chicken.name=Chicken Egg
+item.egg.chicken.name=Egg
 item.egg.chicken.desc=Egg.
 item.tool.compass.name=Compass
 item.tool.compass.desc=Always points to home.
diff --git a/src/common/resources/lang/en_US/subtitles.lang b/src/common/resources/lang/en_US/subtitles.lang
index 3cb37f19b..2853ba3af 100644
--- a/src/common/resources/lang/en_US/subtitles.lang
+++ b/src/common/resources/lang/en_US/subtitles.lang
@@ -31,6 +31,7 @@ subtitles.mob.ghast.scream=Ghast Scream
 subtitles.mob.ghast.affectionate_scream=Ghast affectionate scream
 subtitles.mob.creeper=Creeper hiss
 subtitles.mob.creeper.death=Creeper death
+subtitles.mob.creeper.fuse=Creeper fuse
 subtitles.mob.spider.death=Spider death
 subtitles.mob.spider=Spider hiss
 subtitles.mob.ghast.charge=Ghast charging
@@ -49,9 +50,12 @@ subtitles.portal.portal=Portal ambience
 subtitles.portal.trigger=Portal trigger
 subtitles.portal.travel=Portal travel
 
+subtitles.item.pickup=Item pickup
+
 subtitles.random.fizz=Fizzing
 subtitles.random.drr=Arrow drr
 subtitles.random.fuse=Fuse lit
+subtitles.random.skate=Skating
 subtitles.random.pop=Pop
 subtitles.random.glass=Glass
 subtitles.random.door_open=Door opened
@@ -71,6 +75,12 @@ subtitles.note.bd=Note bd
 subtitles.note.pling=Note pling
 subtitles.note.hat=Note hat
 subtitles.note.bassattack=Note bass attack
+subtitles.note.chant=Note chant
+subtitles.note.drum_steel=Note steel drum
+subtitles.note.chip_triangle=Note triangle wave
+subtitles.note.guitar_electric=Note electric guitar
+subtitles.note.celesta=Note celesta
+subtitles.note.wood_block=Note wood block
 
 subtitles.ambient.weather.thunder=Thunder
 subtitles.ambient.cave=Cave ambience
@@ -79,6 +89,16 @@ subtitles.ambient.weather.rain=Rainfall
 subtitles.tile.piston.out=Piston extended
 subtitles.tile.piston.in=Piston retracted
 
+subtitles.tile.tnt.fuse=TNT lit
+subtitles.tile.sensor_block.sense=Mob sensed
+
+subtitles.tile.dispenser.click=Dispenser click
+subtitles.tile.dispenser.eject=Dispenser eject
+subtitles.tile.dispenser.fire=Dispenser fire
+
+subtitles.tile.activator.click=Activator click
+subtitles.tile.activator.use=Activator use
+
 subtitles.hurt.flesh=Hurt flesh
 
 subtitles.fire.ignite=Fire lit
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 44fd0e8b2..7f00ea053 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -28,12 +28,14 @@ import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypeGroups;
 
+import javax.imageio.ImageIO;
 import javax.swing.JLabel;
 import javax.swing.JOptionPane;
 
@@ -378,6 +380,7 @@ public class Minecraft
     
     public void startGame() throws LWJGLException
     {
+        ImageIO.setUseCache(false); // Speeds up boot time
         LOGGER.info("LWJGL version = {}", org.lwjgl.Sys.getVersion());
         if (Integer.parseInt(org.lwjgl.Sys.getVersion().substring(0, 1)) < 3) {
             JOptionPane.showMessageDialog(null,
@@ -928,7 +931,7 @@ public class Minecraft
                         catch(MinecraftException e)
                         {
                             theWorld = null;
-                            LOGGER.error("MinecraftException occurred while attempting to run tick, existing world!", e);
+                            LOGGER.error("MinecraftException occurred while attempting to run tick, exiting world!", e);
                         }
                         changeWorld(null);
                         displayScreen(new ConflictWarningScreen());
@@ -946,7 +949,11 @@ public class Minecraft
                     if(theWorld != null)
                     {
                     	Debug.change("updatelight");
-                        theWorld.updatingLighting();
+                        try {
+                            theWorld.updatingLighting();
+                        } catch (Throwable t) {
+                            LOGGER.error("Unhandled exception when updating lighting!", t);
+                        }
                         Debug.change("misc");
                     }
                     
@@ -1042,6 +1049,13 @@ public class Minecraft
                 }
                 catch(Throwable throwable)
                 {
+                    if (theWorld != null) {
+                        try {
+                            changeWorld(null);
+                        } catch (Throwable t) {
+                            LOGGER.error("Exception when panic leaving world!", t);
+                        }
+                    }
                     freeUpMemory();
                     onMinecraftCrash(new UnexpectedThrowable("Unexpected error", throwable));	
                 }
@@ -1680,13 +1694,33 @@ public class Minecraft
                 {
                     theWorld.lightningFlicker--;
                 }
-                theWorld.updateEntities();
+                try {
+                    theWorld.updateEntities();
+                } catch (StackOverflowError stackOverflowError) {
+                    LOGGER.error("Stack overflow while updating world entities! Closing world!", stackOverflowError);
+                    changeWorld(null);
+                    throw new RuntimeException(stackOverflowError);
+                } catch (Throwable t) {
+                    LOGGER.error("Unhandled exception while updating world entities! Closing world!", t);
+                    changeWorld(null);
+                    throw t;
+                }
                 Debug.change("misc");
             }
             if(!isGamePaused || isMultiplayerWorld())
             {
                 Debug.change("world");
-                theWorld.tick();
+                try {
+                    theWorld.tick();
+                } catch (StackOverflowError stackOverflowError) {
+                    LOGGER.error("Stack overflow while updating world entities! Closing world!", stackOverflowError);
+                    changeWorld(null);
+                    throw new RuntimeException(stackOverflowError);
+                } catch (Throwable t) {
+                    LOGGER.error("Unhandled exception while ticking world! Closing world!", t);
+                    changeWorld(null);
+                    throw t;
+                }
                 Debug.change("misc");
             }
             if(!isGamePaused && theWorld != null)
@@ -2132,7 +2166,7 @@ public class Minecraft
         }
     }
 
-    public void usePortal(int dim)
+    public void usePortal(int dim, @Nullable DyeColor portalColor)
     {
         Dimension lastDim = Dimension.getDimensionList().get(thePlayer.dimension);
         Dimension newDim = Dimension.getDimensionList().get(dim);
@@ -2179,7 +2213,7 @@ public class Minecraft
         {
             thePlayer.moveTo(x, y, z, thePlayer.yRot, thePlayer.xRot);
             theWorld.updateEntityWithOptionalForce(thePlayer, false);
-            (new PortalHandler()).teleportEntity(theWorld, thePlayer, lastDim, newDim);
+            (new PortalHandler()).teleportEntity(theWorld, thePlayer, portalColor, lastDim, newDim);
         }
     }
 
@@ -2395,7 +2429,7 @@ public class Minecraft
     	@Nullable Player previousPlayer = thePlayer;
         if(!theWorld.isClientSide && !theWorld.dimension.defaultWorldType.mayRespawn())
         {
-            usePortal(targetDimension);
+            usePortal(targetDimension, null);
         }
 
         ChunkCoordinates spawnCoordinates = null;
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index f5a6351f7..7eb242902 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -37,7 +37,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new BubbleParticle(world, x, y, z, motionX, motionY, motionZ, true));
         addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new SmokeParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new NoteParticle(world, x, y, z, motionX, motionY, motionX, data));
-        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new PortalParticle(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new PortalParticle(world, x, y, z, motionX, motionY, motionX, data));
         addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ExplodeParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.ORANGE));
         addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.BLUE));
diff --git a/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java b/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
index 5fb1b84f6..557b522ba 100644
--- a/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
@@ -2,6 +2,8 @@ package net.minecraft.client.entity.particle;
 
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.world.World;
 
 public class PortalParticle extends Particle {
@@ -10,7 +12,7 @@ public class PortalParticle extends Particle {
     private final double yStart;
     private final double zStart;
 
-    public PortalParticle(World world, double x, double y, double z, double xd, double yd, double zd) {
+    public PortalParticle(World world, double x, double y, double z, double xd, double yd, double zd, int data) {
         super(world, x, y, z, xd, yd, zd);
         this.xd = xd;
         this.yd = yd;
@@ -20,9 +22,11 @@ public class PortalParticle extends Particle {
         this.zStart = this.z = z;
         float br = this.random.nextFloat() * 0.6F + 0.4F;
         this.oSize = this.size = random.nextFloat() * 0.2F + 0.5F;
+        Color color = Colors.allPortalColors[data];
         this.rCol = this.gCol = this.bCol = br;
-        this.gCol *= 0.3F;
-        this.rCol *= 0.9F;
+        this.rCol *= color.getRed()/255f;
+        this.gCol *= color.getGreen()/255f;
+        this.bCol *= color.getBlue()/255f;
         this.lifetime = (int) (Math.random() * 10D) + 40;
         this.noPhysics = true;
         this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + (int) (Math.random() * 8D));
diff --git a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index b61ffaf0b..640994d73 100644
--- a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -164,11 +164,11 @@ public class LocalPlayer extends Player
                     int targetDim = ((PortalBlock) Block.blocksList[portalID]).targetDimension;
                     if (dimension == targetDim)
                     {
-                        mc.usePortal(0);
+                        mc.usePortal(0, portalColor);
                     }
                     else
                     {
-                        mc.usePortal(targetDim);
+                        mc.usePortal(targetDim, portalColor);
                     }
                 }
             }
diff --git a/src/main/java/net/minecraft/client/gui/GameOverScreen.java b/src/main/java/net/minecraft/client/gui/GameOverScreen.java
index 0faff9750..7bdb3156f 100644
--- a/src/main/java/net/minecraft/client/gui/GameOverScreen.java
+++ b/src/main/java/net/minecraft/client/gui/GameOverScreen.java
@@ -56,6 +56,9 @@ public class GameOverScreen extends Screen
         }
         if(button.id == 2)
         {
+            if (mc.isMultiplayerWorld()) {
+                mc.theWorld.sendQuittingDisconnectingPacket();
+            }
             mc.changeWorld(null);
             mc.displayScreen(new MainMenuScreen());
         }
diff --git a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
index 213eac8ca..6c6ab960a 100644
--- a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
+++ b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
@@ -15,6 +15,8 @@ import net.minecraft.client.gui.chat.ChatScreen;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.PhotoModeScreen;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.PortalBlock;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.util.helper.Direction;
@@ -942,7 +944,7 @@ public class IngameHud extends Gui
         GL11.glDepthMask(false);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, intensity);
-        IconCoordinate portal = TextureRegistry.getTexture("minecraft:block/portal_nether");
+        IconCoordinate portal = BlockModelDispatcher.getInstance().getDispatch(Block.getBlock(mc.thePlayer.portalID)).getBlockTextureFromSideAndMetadata(Side.NORTH, mc.thePlayer.portalColor.blockMeta << 4 | PortalBlock.MASK_COLOR_SET);
         portal.parentAtlas.bind();
         float f1 = (float) portal.getIconUMin();
         float f2 = (float) portal.getIconVMin();
diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index ca39d4ace..4184689ad 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -539,7 +539,7 @@ public class ClientPacketHandler extends PacketHandler
         {
             // this class does not seem to handle pick up from server dropped items. find where it is.
             // something about that isn't working on servers if the player changed their gamemode.
-            worldClient.playSoundAtEntity(null, item, "random.pop", 0.2F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 2.0F);
+            worldClient.playSoundAtEntity(null, item, "item.pickup", 1F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 4.0F);
             mc.particleEngine.add(new TakeAnimationParticle(mc.theWorld, item, collector, -0.5F));
             worldClient.removeEntityFromWorld(takeItemEntityPacket.collectedEntityId);
         }
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
index fd6f4601d..65d282ec9 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
@@ -101,6 +101,7 @@ public class ThreadDownloadResources extends Thread {
                 long size = tag.getAsContentTag().get("Size").getAsStringTag().getLong();
 
                 File soundFile = new File(resourcesFolder, "minecraft/sounds/" + fileName);
+                soundFile.mkdirs();
 
                 if (!soundFile.isFile() || (!mc.gameSettings.allowSoundOverrides.value && soundFile.length() != size)) {
                     entries.add(new SoundEntry(soundFile, name, size));
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 10a5c7881..b11dcc35d 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1718,15 +1718,15 @@ public class RenderGlobal
                 break;
 
             case EVENT_DISPENSER_EMPTY: // Dispenser empty click
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.click", 1.0F, 1.2F);
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.click", 1.0F, 1.0F);
                 break;
 
             case EVENT_DISPENSER_ITEM: // Dispenser fire item
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.click", 1.0F, 1.0F);
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.eject", 1.0F, 1.0F);
                 break;
 
             case EVENT_DISPENSER_PROJECTILE: // Dispenser fire projectile
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.bow", 1.0F, 1.2F);
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.fire", 1.0F, 1.2F);
                 break;
 
             case EVENT_DISPENSER_PARTICLES: // Dispenser eject particles
diff --git a/src/main/java/net/minecraft/client/render/TextureManager.java b/src/main/java/net/minecraft/client/render/TextureManager.java
index f9a052b97..7264eec72 100644
--- a/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -93,7 +93,7 @@ public class TextureManager {
                 addDynamicTexture(new DynamicTextureWaterFlow(TextureRegistry.getTexture("minecraft:block/water_flowing")));
                 addDynamicTexture(new DynamicTextureLavaStill(TextureRegistry.getTexture("minecraft:block/lava_still")));
                 addDynamicTexture(new DynamicTextureLavaFlowing(TextureRegistry.getTexture("minecraft:block/lava_flowing")));
-                addDynamicTexture(new DynamicTexturePortal(TextureRegistry.getTexture("minecraft:block/portal_nether"),false));
+//                addDynamicTexture(new DynamicTexturePortal(TextureRegistry.getTexture("minecraft:block/portal_nether"),false));
                 addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire")));
 
                 String[] fireflycolors = new String[] {"blue", "orange", "green", "red"};
diff --git a/src/main/java/net/minecraft/client/render/block/color/PortalBlockColor.java b/src/main/java/net/minecraft/client/render/block/color/PortalBlockColor.java
new file mode 100644
index 000000000..2d540391f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/color/PortalBlockColor.java
@@ -0,0 +1,16 @@
+package net.minecraft.client.render.block.color;
+
+import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.world.WorldSource;
+
+public class PortalBlockColor extends BlockColor{
+    @Override
+    public int getFallbackColor(int meta) {
+        return Colors.allPortalColors[(meta >> 4) & 0xF].getARGB();
+    }
+
+    @Override
+    public int getWorldColor(WorldSource world, int x, int y, int z) {
+        return Colors.allPortalColors[(world.getBlockMetadata(x, y, z) >> 4) & 0xF].getARGB();
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 6ed2a42b9..d82b4aed1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -446,8 +446,8 @@ public class BlockModelDispatcher
 
         addDispatch(new StandardBlockModel<>(Blocks.GLOWSTONE).withTextures("minecraft:block/glowstone"));
 
-        addDispatch(new PortalBlockModel<>(Blocks.PORTAL_NETHER).withTextures("minecraft:block/portal_nether"));
-        addDispatch(new PortalBlockModel<>(Blocks.PORTAL_PARADISE).withTextures("minecraft:block/portal_nether"));
+        addDispatch(new PortalBlockModel<>(Blocks.PORTAL_NETHER, "minecraft:block/portal_nether/").withTextures("minecraft:block/portal_nether"));
+        addDispatch(new PortalBlockModel<>(Blocks.PORTAL_PARADISE, "minecraft:block/portal_paradise/").withTextures("minecraft:block/portal_nether"));
 
         addDispatch(new CakeBlockModel<>(Blocks.CAKE).withTextures("minecraft:block/cake/top", "minecraft:block/cake/bottom", "minecraft:block/cake/side"));
         addDispatch(new PumpkinPieBlockModel<>(Blocks.PUMPKIN_PIE).withTextures("minecraft:block/pumpkin_pie/top", "minecraft:block/pumpkin_pie/bottom", "minecraft:block/pumpkin_pie/side"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/PortalBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PortalBlockModel.java
index a3adb1a79..6384d6308 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PortalBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PortalBlockModel.java
@@ -1,11 +1,20 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.PortalBlock;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class PortalBlockModel<T extends Block> extends TransparentBlockModel<T> {
-    public PortalBlockModel(Block block) {
+public class PortalBlockModel<T extends PortalBlock> extends TransparentBlockModel<T> {
+    protected IconCoordinate[] colors = new IconCoordinate[16];
+    public PortalBlockModel(Block block, String rootTexKey) {
         super(block, false);
+        for (DyeColor color : DyeColor.values()) {
+            colors[color.blockMeta] = TextureRegistry.getTexture(rootTexKey + color.colorID);
+        }
     }
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
@@ -14,24 +23,11 @@ public class PortalBlockModel<T extends Block> extends TransparentBlockModel<T>
         {
             return false;
         }
-        boolean flag = blockAccess.getBlockId(x - 1, y, z) == block.id && blockAccess.getBlockId(x - 2, y, z) != block.id;
-        boolean flag1 = blockAccess.getBlockId(x + 1, y, z) == block.id && blockAccess.getBlockId(x + 2, y, z) != block.id;
-        boolean flag2 = blockAccess.getBlockId(x, y, z - 1) == block.id && blockAccess.getBlockId(x, y, z - 2) != block.id;
-        boolean flag3 = blockAccess.getBlockId(x, y, z + 1) == block.id && blockAccess.getBlockId(x, y, z + 2) != block.id;
-        boolean flag4 = flag || flag1;
-        boolean flag5 = flag2 || flag3;
-        if(flag4 && side == 4)
-        {
-            return true;
-        }
-        if(flag4 && side == 5)
-        {
-            return true;
-        }
-        if(flag5 && side == 2)
-        {
-            return true;
-        }
-        return flag5 && side == 3;
+        return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+        return colors[block.fromMetadata(data).blockMeta];
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
index 170bc5cb5..20fa51499 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
@@ -1,11 +1,17 @@
 package net.minecraft.client.render.dynamictexture;
 
+import java.awt.image.BufferedImage;
+import java.io.File;
+import java.io.IOException;
 import java.util.Random;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 
+import javax.imageio.ImageIO;
+
 public class DynamicTexturePortal extends DynamicTexture{
 	
 	private boolean altTexture;
@@ -71,20 +77,26 @@ public class DynamicTexturePortal extends DynamicTexture{
 					int g = (int)(f * f * f * f * 255.0F);
 					int a = (int)(f * 100.0F + 155.0F);
 					int l = y * targetTexture.width + x;
-					
-					this.portalTextureData[i][l * 4 + 0] = (byte)r;
-					this.portalTextureData[i][l * 4 + 1] = (byte)g;
-					this.portalTextureData[i][l * 4 + 2] = (byte)b;
+
+//					double bD = (f * 100.0D + 155.0D);
+//					double rD = (f * f * 200.0D + 55.0D);
+//					double gD = (f * f * f * f * 255.0D);
+//					int luma = (int) (MathHelper.clamp((0.299 * rD + 0.587 * gD + 0.114 * bD), 0, 1) * 255);
+
+					this.portalTextureData[i][l * 4 + 0] = (byte)r /*luma*/;
+					this.portalTextureData[i][l * 4 + 1] = (byte)g /*luma*/;
+					this.portalTextureData[i][l * 4 + 2] = (byte)b /*luma*/;
 					this.portalTextureData[i][l * 4 + 3] = (byte)a;
 				}
 			}
 		}
+
+//		exportAnimationStrip();
 	}
 
 	@Override
 	public void update() {
 		++this.portalTickCounter;
-		
 		byte[] var1 = this.portalTextureData[this.portalTickCounter & 31];
 
 		for(int i = 0; i < targetTexture.getArea(); ++i) {
@@ -99,4 +111,34 @@ public class DynamicTexturePortal extends DynamicTexture{
 			this.imageData[i * 4 + 3] = (byte)a;
 		}
 	}
+
+	public void exportAnimationStrip() {
+		File output = new File("./debug/portal_anim_grey.png");
+		output.mkdirs();
+        try {
+            output.createNewFile();
+        } catch (IOException e) {
+            throw new RuntimeException(e);
+        }
+
+		BufferedImage portalImage = new BufferedImage(targetTexture.width, targetTexture.height * 32, BufferedImage.TYPE_INT_ARGB);
+		for (int frame = 0; frame < portalTextureData.length; frame++) {
+			byte[] frameImage = portalTextureData[frame];
+			for(int i = 0; i < targetTexture.getArea(); ++i) {
+				int r =frameImage[i * 4 + 0] & 255;
+				int g =frameImage[i * 4 + 1] & 255;
+				int b =frameImage[i * 4 + 2] & 255;
+				int a =frameImage[i * 4 + 3] & 255;
+
+				int argb = Color.intToIntARGB(a, r, g, b);
+				portalImage.setRGB(i % targetTexture.width, (i / targetTexture.height) + targetTexture.height * frame, argb);
+			}
+		}
+
+        try {
+            ImageIO.write(portalImage, "png", output);
+        } catch (IOException e) {
+            throw new RuntimeException(e);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/client/sound/SoundEngine.java b/src/main/java/net/minecraft/client/sound/SoundEngine.java
index c20b8064d..8d326f7ad 100644
--- a/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -160,10 +160,18 @@ public class SoundEngine
 	}
 
 	public void playSoundWithID(String name, SoundCategory category, float volume, final float pitch, String soundID) {
-		playSoundWithID(SoundRepository.SOUNDS.getSoundEntry(name), category, volume, pitch, soundID);
+		playSoundWithID(name, category, volume, pitch, soundID, true);
+	}
+
+	private void playSoundWithID(String name, SoundCategory category, float volume, final float pitch, String soundID, boolean allowSubtitle) {
+		playSoundWithID(SoundRepository.SOUNDS.getSoundEntry(name), category, volume, pitch, soundID, allowSubtitle);
 	}
 
 	public void playSoundWithID(SoundEntry entry, SoundCategory category, float volume, final float pitch, String soundID) {
+		playSoundWithID(entry, category, volume, pitch, soundID, true);
+	}
+
+	private void playSoundWithID(SoundEntry entry, SoundCategory category, float volume, final float pitch, String soundID, boolean allowSubtitle) {
 		if (!loaded || soundSystem == null || muted || !SoundCategoryHelper.isAnyEnabled(options))
 		{
 			return;
@@ -186,20 +194,27 @@ public class SoundEngine
 					soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, options) * entry.volume);
 					soundSystem.play(soundID);
 				}
-				if (entry.parent.hasSubtitle()) {
-					mc.subtitleTracker.heardSound(entry.parent, 0, 0, 0);
-				}
 			} else if (entry.type == SoundEntry.Type.EVENT) {
-				playSoundWithID(entry.name, category, volume, pitch, soundID);
+				playSoundWithID(entry.name, category, volume * entry.volume, pitch * entry.pitch, soundID, false);
+			}
+			if (allowSubtitle && entry.parent.hasSubtitle()) {
+				mc.subtitleTracker.heardSound(entry.parent, 0, 0, 0);
 			}
 		}
 	}
 
 	public void playSoundWithIdAtPos(String name, SoundCategory category, float x, float y, float z, float volume, final float pitch, String soundID) {
-		playSoundWithIdAtPos(SoundRepository.SOUNDS.getSoundEntry(name), category, x, y, z, volume, pitch, soundID);
+		playSoundWithIdAtPos(name, category, x, y, z, volume, pitch, soundID, true);
 	}
 
+	private void playSoundWithIdAtPos(String name, SoundCategory category, float x, float y, float z, float volume, final float pitch, String soundID, boolean allowSubtitle) {
+		playSoundWithIdAtPos(SoundRepository.SOUNDS.getSoundEntry(name), category, x, y, z, volume, pitch, soundID, allowSubtitle);
+	}
 	public void playSoundWithIdAtPos(SoundEntry entry, SoundCategory category, float x, float y, float z, float volume, final float pitch, String soundID) {
+		playSoundWithIdAtPos(entry, category, x, y, z, volume, pitch, soundID, true);
+	}
+
+	private void playSoundWithIdAtPos(SoundEntry entry, SoundCategory category, float x, float y, float z, float volume, final float pitch, String soundID, boolean allowSubtitle) {
 		if (!loaded || muted || soundSystem == null || !SoundCategoryHelper.isAnyEnabled(options)) {
 			return;
 		}
@@ -227,11 +242,11 @@ public class SoundEngine
 					soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, options) * entry.volume);
 					soundSystem.play(soundID);
 				}
-				if (entry.parent.hasSubtitle()) {
-					mc.subtitleTracker.heardSound(entry.parent, x, y, z);
-				}
 			} else if (entry.type == SoundEntry.Type.EVENT) {
-				playSoundWithIdAtPos(entry.name, category, x, y, z, volume, pitch, soundID);
+				playSoundWithIdAtPos(entry.name, category, x, y, z, volume * entry.volume, pitch * entry.pitch, soundID, false);
+			}
+			if (allowSubtitle && entry.parent.hasSubtitle()) {
+				mc.subtitleTracker.heardSound(entry.parent, x, y, z);
 			}
 		}
 	}
